#!/bin/perl

#
# Eric GARREAU, 1997
# BPL (Bob Public License) : register to the Mailing List of this product
# 'Le Petit Bob' at 'egarreau@free.fr'
#


#
# Avis au lecteur : merci d'etre indulgent, c'est mon premier jour de Perl...
#

#
# bon, d'accord : ces fichiers ont evolue, depuis mon premier jour de Perl...
#



# ce script utilise les fichiers suivants :
#
# nom : $TWSFILES/trees_to_browse.[dir,pag]
# type : hash des repertoires "physiques" a scruter, avec leurs chemins
#         equivalents (par rapport a 'http://server/')  et les proprietaires
#         (pour que les fichiers crees leur appartiennent...). Ce hash
#         contient egalement les sous-arborescences a EXCLURE de la
#         scrutation globale (pour ne pas faire exploser les tableaux !)
# usage : ce script ne s'interesse qu'aux arborescences a scruter
#
#


# ce script genere les fichiers suivants :
#
# nom : $TWSFILES/megalist_of_dirs
# type : liste de tous les repertoires NON proteges par la directive '.keep'
# usage : permet de :
#          - faire les 'txt2html' sur le fichiers '.txt'
#          - generer automatiquement 'index.html' si '$dir/index.auto' existe
# format : chemin_complet du repertoire, sans le '/' final
#





require 5;
use ANYDBM_File;;



# la base de l'arborescence Intranet
$TWSROOT=$ENV{"TWSROOT"};
$TWSTOOLS=$ENV{"TWSTOOLS"};
$TWSFILES=$ENV{"TWSFILES"};

die "Variables \$TWS[TOOLS,FILES] non definies --> il faut sourcer '.twsrc'\n" if ($TWSROOT eq '' or $TWSTOOLS eq '' or $TWSFILES eq '');

# forcer le parcours des arborescences meme si les fichiers sont recents
$scanFiles=();
if($ARGV[0] =~ /force/i)
{
    $scanFiles=1;
}




# niveau de debug, pour les traces 'print XXX if $debug > N'
$debug=0;



# les fichiers, planques dans le repertoire '$TWSFILES'
$dirsmegalist="$TWSFILES/megalist_of_dirs";

$tmpdirsmegalist="$TWSFILES/megalist_of_dirs_$$";
$keepsmegalist="$TWSFILES/megalist_of_keeps";




    



# creer la liste de tous les repertoires
# et filtrer les bouts proteges par le '.keep'
# (refaire le fichier si il n'a pas ete modifie depuis au moins 0,8 jour)
# (sinon, effacer le fichier 'megalist' pour forcer sa creation)
if ((! -e $dirsmegalist) || (-C $dirsmegalist > 0.8) || ($scanFiles))
{
    my %trees;
    my $treeshash="$TWSFILES/list_of_trees";


    # effacer les fichiers
    unlink $tmpdirsmegalist;
    unlink $keepsmegalist;

    # la liste de toutes les arborescences a parcourir

    # 0x0000 = O_READONLY
    # 0 = pas de masque de creation
    tie(%trees, SDBM_File, $treeshash, 0x0000, 0) or die "I need a browse database !\n";


    # parcourir toutes les arborescences (tout, puis les '.keep')
    foreach $tree (keys(%trees))
    {
	# ne pas parcourir les 'excludedtrees'...
	next if($trees{$tree} eq 'exclude');

	# laisser les traces pour montrer que ca va prendre un certain temps...
	print "find $tree -type d -print >> \$dirsmegalist...\n...";
	system "find $tree -type d -print >> $tmpdirsmegalist";
	print " done.\n";

	print "find $tree -name .keep -print >> \$keepsmegalist...\n...";
	system "find $tree -name .keep -print >> $keepsmegalist";
	print " done.\n";
	
    }

    untie(%trees);


    # charger tout le fichier des 'keeps' en en seule fois
    $save_IRS=$/;
    undef $/;
    open(FILE, "< $keepsmegalist");
    $keeps=<FILE>;     # tout le fichier dans '$keeps', merci Perl...
    close(FILE);
    $/=$save_IRS;
    
    # ne conserver que les repertoires (enlever '/.keep/')
    $keeps =~ s/\/\.keep//gm;


    # charger tout le fichier des repertoires en en seule fois
    $save_IRS=$/;
    undef $/;
    open(FILE, "< $tmpdirsmegalist");
    $big=<FILE>;     # tout le fichier dans '$big', merci Perl...
    close(FILE);
    $/=$save_IRS;

    # purger les repertoires CAP
    $big =~ s|^.*\/\.finderinfo\n||gm;
    $big =~ s|^.*\/\.resource\n||gm;

    # boucle ('g') sur le matching des lignes ('.+\n') dans '$keeps'
    while($keeps =~ /(.+)\n/g)
    {
	# purger toutes les arborescences protegees
	# (qui contiennet la base du repertoire)
	$big =~ s|^$1.*\n||gm;
    };
    
    open(FILE, "> $tmpdirsmegalist");
    print FILE $big;
    close(FILE);
    undef $big;

    unlink $dirsmegalist;
    rename $tmpdirsmegalist, $dirsmegalist;

    # ca ne sert plus a rien, ce truc
    unlink $keepsmegalist;
}
else
{
    print " - liste recente -> non refaite.\n";
    print " - effacer '$dirsmegalist' si necessaire.\n";
};














